/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.htmltools;

import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.text.*;

public class Editor
  extends JFrame 
  implements Runnable
{
  private LinkFile lf;
  private Thread loading;
  private File file;

  Editor(LinkFile lf)
  {
    super(lf.toString());
    setSize(500,300);
    this.lf=lf;
    this.loading=new Thread(this);
    this.loading.setPriority(Thread.MIN_PRIORITY);
    this.loading.start();
  }

  public void run()
  {
    java.awt.Container cp=getContentPane();
    JTextArea ta=new JTextArea();
    ta.setEditable(false);
    Document doc=ta.getDocument();
    cp.add(new JScrollPane(ta));
    
    try
    {
      URL url=lf.url;
      if("file".equals(url.getProtocol()))
      {
        File file=new File(url.getFile());
        if(file.canWrite()) this.file=file;
      }

      if(file!=null) ta.setEditable(true);
                else setTitle(getTitle()+" (readonly)");
        
      //System.out.println(url);

      Reader in = new InputStreamReader(url.openStream());
      char[] buff = new char[4096];
      int nch;
      while ((nch = in.read(buff, 0, buff.length)) != -1) 
      {
        String s=new String(buff, 0, nch);
        //System.out.print(s);
        doc.insertString(doc.getLength(), s, null);
      }
    }
    catch(Exception e) {System.err.println(e);}

    loading=null;
  }
  
}
