/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.htmltools;

/**
   An internal anchor of an HTML-URL.
*/
public class LinkAnchor extends LinkTag
{
  protected LinkFile parent;

  protected String name;
  
  protected boolean found;
  
  protected String anchorS;

  LinkAnchor(LinkFile parent, String name)
  {
    this.parent=parent;
    this.name=name;
    this.found=false;
  }

  LinkAnchor(LinkFile parent, String name, boolean found)
  {
    this.parent=parent;
    this.name=name;
    this.found=found;
  }
  
  final synchronized void toFound()
  {
    found=true;
    referrers=null;
  }
  
  public final boolean isFound()
  {
    return found;
  }

  public final String toString()
  {
    if(anchorS!=null) 
      return anchorS;
    else
      return (anchorS=(parent.toString()+"#"+name));
  }
  
  synchronized final void addReferrer(LinkFile referrer) 
  {
    if(!found) 
      referrers.addElement(referrer);
  }
  
  public final String getError()
  {
    return "anchor not found: \""+name+"\"";
  }

  public final String getName()
  {
    return name;
  }
    
}
