/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.htmltools;

public interface LinkFrontend
{
  /** 
    Notifies the frontend whenever a url is getting checked.
    @param tag the url getting checked.
    @param thread the thread which processes this url.
  */
  public void onLookup(LinkTag tag, int thread);

  /**
    Notifies the Frontend, that a spider thread is waiting because 
    lack of work.
    @param thread the thread waiting.
  */
  public void onWaiting(int thread);
  
  /**
    Notifies the frontend, that the spider has terminated itself normally.
    Not called, when the spider is aborted via stop.
    @see LinkSpider#stop()
  */
  public void onEnd();

  /**
    Notifies the frontend that an url is found to be broken.
    @param tag the invalid url
  */
  public void onAbsent(LinkTag tag);
  
  /**
    Notifies the frontend, that a target frame name changed it's 
    state.
    @param target the target changed
  */
  public void onTarget(LinkTarget target);
  
}
