/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.htmltools;

import java.net.URL;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

public abstract class LinkTag
{
  /**
    A vector of LinkTags holding all urls reffering to this url.
    This information is discarded, when the LinkTag gets status
    found.
  */
  protected Vector referrers=new Vector();
  
  abstract String getError();

  public final Enumeration getReferrers() 
  { 
    return referrers.elements(); 
  }
  
  /**
    Replaces all the backslashes in a string with slashes.
    This is used to get file-urls of windows-systems
    canonized.
  */
  public static final String replaceBackslashes(String s)
  {
    if(s.indexOf((int)'\\')<0)
    {
      return s;
    }
    else
    {
      StringBuffer b=new StringBuffer(s);
      int pos=-1;
      while((pos=s.indexOf((int)'\\',pos+1))>=0)
        b.setCharAt(pos,'/');
      return new String(b);
    }    
  }

}
