/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.htmltools;

/**
   A frame target.
*/
public class LinkTarget extends LinkTag
{
  protected String name;
  protected int number;
  protected LinkFile definer;
  protected String targetS;
  
  LinkTarget(LinkFile lf, String name, int number, boolean definition)
  {
    this.name=name;
    this.number=number;
    updateState(lf, definition);
  }
  
  public final boolean updateState(LinkFile lf, boolean definition)
  {
    boolean update;
    if(definition) 
    { 
      update=true; 
      definer=lf;
    }
    else 
    { 
      update=referrers.isEmpty(); 
      referrers.addElement(lf); 
    }

    if(update)
      targetS=(number+1)+": \""+name+((definer==null) 
          ? "\" UNDEFINED"  
          : "\" defined by \""+definer.toString()+"\"" );
        
    return update;
  }

  public final String toString()
  {
    return targetS;
  }

  public final String getError()
  {
    return "target";
  }

  public final String getName()
  {
    return name;
  }
  
  public final int getNumber()
  {
    return number;
  }
  
  public final LinkFile getDefiner()
  {
    return definer;
  }
    
}
