/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.htmltools;

import java.awt.event.*;
import javax.swing.*;

public class MemoryModel
  extends DefaultBoundedRangeModel 
  implements ActionListener
{
  private Runtime rt;
  
  MemoryModel()
  {
    super(0,0,0,0);
    rt=Runtime.getRuntime();
    updateMemory();
  }

  public void updateMemory()
  {
    //System.out.println("MemoryModel.updateMemory("+rt.totalMemory()+'|'+rt.freeMemory()+')');
    long total=rt.totalMemory();
    setMaximum(convert(total));
    setValue(convert(total-rt.freeMemory()));
  }  
  
  public void actionPerformed(ActionEvent e)
  {
    updateMemory();
  }
  
  public static final int convert(long l)
  {
    l=l>>10;
    return (l>(long)Integer.MAX_VALUE) ? Integer.MAX_VALUE : (int)l;
  }
  
}
