/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.htmltools;

import java.awt.Frame;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.Dialog;
import java.awt.Label;
import java.awt.Button;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;

public class MessageDialog 
  extends Dialog 
  implements ActionListener, WindowListener
{
  public MessageDialog(Frame parent, String title, String m)
  {
    super(parent, title, true);
    setSize(300,200);
    addWindowListener(this);

    setLayout(new BorderLayout());
    {
      Panel P=new Panel(new GridLayout(0,1,0,0));

      int sep=(int)'\n';
      int a=0;
      int e=m.indexOf(sep); if(e<0)e=m.length();
      do
      {
        P.add(new Label(m.substring(a,e),Label.CENTER));
        if(e>=m.length()) break;
        a=e+1;
        e=m.indexOf(sep,a); if(e<0)e=m.length();
      }
      while(true);

      add(P, BorderLayout.NORTH);
    }

    Button bt;
    add(bt=new Button("OK"), BorderLayout.SOUTH);
    bt.addActionListener(this);
  }

  public void actionPerformed(ActionEvent e){dispose();}
  
  public void windowActivated(WindowEvent e){}
  public void windowDeactivated(WindowEvent e){}
  public void windowDeiconified(WindowEvent e){}
  public void windowIconified(WindowEvent e){}
  public void windowOpened(WindowEvent e){}
  public void windowClosing(WindowEvent e){dispose();}
  public void windowClosed(WindowEvent e){}

  public static void main(String[] args)
  {
    Frame f=new Frame("Frame");
    f.show();
    (new MessageDialog(f, "Beispiel", "The url youve entered is not valid\nPlease enter another one. Or make\nsomething else.")).show();

  }

}
