/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.token;

/**
  A program using the HtmlTokenizer should implement this interface
  to get messages about the progress and results of the parser.
*/

public interface HtmlConsumer
{
  /**
    Notifies the Consumer, that an opening html tag has been encountered.
    This works only for registered tags. 
    @see HtmlTokenizer#addTag(java.lang.String, int, java.lang.String[])
    @param code the code provided on tag registration
    @param tag the tag name itself
    @param attr the tag attributes as registered
  */
  int onOpeningTag(int code, String tag, String[] attr);
  
  /**
    Notifies the Consumer, that an closing html tag has been encountered.
    @param code the code provided on tag registration
    @param tag the tag name itself
  */    
  int onClosingTag(int code, String tag);
  
  void onText(FastInput in) throws java.io.IOException, FastInput.EndException;
}
