/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.token.test;

import de.rw7.token.FastInput;
import java.io.InputStream;
import java.io.IOException;
import java.io.FileInputStream;

/**
  Performs a small test suite for FastInput.
  Requires the source code TokenTest.java.
  @see de.rw7.token.FastInput
*/
public class FastInputTest
{
  public static void main(String[] args)
  {
    try
    {
      int len=0;
      byte[] buf=new byte[50000];
      FastInput fis=new FastInput(64);

      fis.open(FastInputTest.class.getResourceAsStream("/de/rw7/token/test/FastInputTest.java"));
      try
      {
        for(len=0; ; len++) buf[len]=(byte)(fis.read());
      }
      catch(FastInput.EndException e){}
      System.out.println("Length: "+len);
      
      fis.open(FastInputTest.class.getResourceAsStream("/de/rw7/token/test/FastInputTest.java"));
      try
      {
        while(true) 
        {
          fis.skipUntil((byte)'{');
          //System.out.println(fis.getBytesRead());
          if(buf[fis.getBytesRead()-1]!=(byte)'{') throw new IllegalArgumentException();
        }  
      }
      catch(FastInput.EndException e){}

      try
      {
        fis.open(FastInputTest.class.getResourceAsStream("/de/rw7/token/test/FastInputTest.java"));
        while(true)
        {
          byte x=(byte)(fis.skipUntil((byte)'F',(byte)'i'));
          if(buf[fis.getBytesRead()-1]!=(byte)'F'&&
             buf[fis.getBytesRead()-1]!=(byte)'i'||
             buf[fis.getBytesRead()-1]!=x) throw new IllegalArgumentException();
        }  
      }
      catch(FastInput.EndException e){}

      try
      {
        fis.open(FastInputTest.class.getResourceAsStream("/de/rw7/token/test/FastInputTest.java"));
        fis.skipUntil((byte)'\n');
        if(fis.getBytesRead()!=3) throw new IllegalArgumentException();
        fis.skipWhile((byte)' ');
        if(fis.read()!='C') throw new IllegalArgumentException();
        if(fis.getBytesRead()!=6) throw new IllegalArgumentException();
        fis.close();
      }
      catch(FastInput.EndException e){System.err.println("Unexpected: "+e);}

    }
    catch(IOException e) { System.err.println(e); }
  }
  
}
