/*
  Copyright (C) 1998 Ralf Wiebicke

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You'll find the GPL at http://www.gnu.org/copyleft/gpl.html
*/

package de.rw7.token.test;

import de.rw7.token.*;
import java.io.*;

public class StreamTest
{
  public static void main(String[] args)
  {
    String file="/opt/history_rw7.tar";
    long time;
    try
    {
      {
        InputStream is=new FileInputStream(file);
        int nbuf=4096;
        byte[] buf=new byte[nbuf];
        time=System.currentTimeMillis();
        while (true)
        {
          int avl=is.available();
          if(avl==0)
          {
            //System.out.print("block ");
            int res=is.read();
            if(res<0) break;
          }
          else
          {
            if(avl>nbuf) avl=nbuf;
            //System.out.print(avl);System.out.print(' ');
            int res=is.read(buf,0,avl);
            if(res!=avl) System.out.print("XXXXXXXXXXXXXXXXXX");
          }
        }
        System.out.println("Stream:"+(System.currentTimeMillis()-time));
      }
      {
        Reader fr=new BufferedReader(new InputStreamReader(new FileInputStream(file)));
        int nbuf=4096;
        char[] buf=new char[nbuf];
        time=System.currentTimeMillis();
        while (true)
        {
          //System.out.print("block ");
          int res=fr.read(buf);
          if(res<0) break;
          //System.out.print(res);System.out.print(' ');
        }
        System.out.println("Reader:"+(System.currentTimeMillis()-time));
      }
      {
        InputStream bis=new BufferedInputStream(new FileInputStream(file));
        time=System.currentTimeMillis();
        while(bis.read()>=0) 
          ;
        System.out.println("BufferedInputStream:"+(System.currentTimeMillis()-time));
      }  
      {
        Reader bfr=new BufferedReader(new FileReader(file));
        time=System.currentTimeMillis();
        while(bfr.read()>=0) 
          ;
        System.out.println("BufferedReader:"+(System.currentTimeMillis()-time));
      }  
    }
    catch(IOException e) {System.err.println(e);}
  }
}
